#include <clip.h>

#define REDUCE

/***************************************************************************/

#define DIR	"C:\\Home\\Emulator\\gb\\roms\\Nintendo GameBoy\\"
//#define FNAME	"Tetris_(JUE)_(V1.1)_[!].zip"
//#define FNAME	"Dr._Mario_(JU)_(V1.1).zip"
//#define FNAME	"Korodice_(J).zip" /* Q[JnȂ */
//#define FNAME	"Space_Invaders_(J).zip" /* _BԂvHSYNC */
//#define FNAME	"Penguin_Land_(J).zip" /* 񂺂_ */
#define FNAME	"Alleyway_(JUE)_[!].zip" /* ̓_ */
//#define FNAME	"Dragon_Slayer_I_(J).zip" /* Q[JnȂ */

/////////////////////////////////////////////////////////////////////////////
#define CLOCK	(1<<22)
#define HCLOCK	456
#define VLINE	154
#define FMSEC	(1000*HCLOCK*VLINE/CLOCK)

#define APPNAME	"GBWIN"
#define WIDTH	160
#define HEIGHT	144
#define SCALE	2
unsigned char vbuff[WIDTH*HEIGHT];

struct {
	DMG cpu;/*memK{*/
	unsigned char mem[0x10000];
} cpu_mem;
DMG* cpu = &cpu_mem.cpu;
unsigned char* mem = cpu_mem.mem;

unsigned char* rom;
int rom_size;

unsigned int DIV_T;
         int DIV_T0;
/////////////////////////////////////////////////////////////////////////////
BITMAPINFO* pBMI;
HWND MainWnd;
LRESULT CALLBACK
WndProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	switch(msg) {
	case WM_DESTROY:
		PostQuitMessage(0);
		return 0;
	case WM_CHAR:
		if(wParam == 'q') {
			DestroyWindow(hWnd);
			return 0;
		}
		return 0;
	}
	return DefWindowProc(hWnd, msg, wParam, lParam);
}
int
DoMsg()
{
	MSG msg;

	while(PeekMessage(&msg, NULL, 0, 0, PM_REMOVE)) {
		if(msg.message == WM_QUIT) {
			return 0;
		}
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}

	return 1;
}
void
InitUI()
{
	int i;
	BITMAPINFOHEADER* bi;
	RGBQUAD* rgb;
	HINSTANCE hInst;
	WNDCLASS wc;
	RECT rcWin;
	RECT rcCli;
	int ncW;
	int ncH;

	pBMI = (BITMAPINFO*)calloc(sizeof(BITMAPINFOHEADER) + sizeof(RGBQUAD) * 256, 1);
	bi = &pBMI->bmiHeader;
	rgb = &pBMI->bmiColors[0];
	bi->biSize = sizeof(BITMAPINFOHEADER);
#ifdef REDUCE
	bi->biWidth = 128;
	bi->biHeight = -88;
#else /*REDUCE*/
	bi->biWidth = WIDTH;
	bi->biHeight = -HEIGHT;
#endif /*REDUCE*/
	bi->biPlanes = 1;
	bi->biBitCount = 8;
	for(i = 0; i < 4; i++) {
		rgb[i].rgbRed   = 255 - (255 * i / 4);
		rgb[i].rgbGreen = 255 - (255 * i / 4);
		rgb[i].rgbBlue  = 255 - (255 * i / 4);
	}

	hInst = GetModuleHandle(NULL);
	//
	memset(&wc, 0, sizeof wc);
	wc.style = CS_HREDRAW | CS_VREDRAW;
	wc.lpfnWndProc = WndProc;
	wc.hInstance = hInst;
	wc.hCursor = LoadCursor(NULL, IDC_CROSS);
	wc.lpszClassName = APPNAME;
	RegisterClass(&wc);
	//
	MainWnd = CreateWindow(APPNAME, APPNAME,
		WS_OVERLAPPED,
		CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT,
		NULL, NULL, hInst, NULL);
	//
	GetWindowRect(MainWnd, &rcWin);
	GetClientRect(MainWnd, &rcCli);
	ncW = (rcWin.right - rcWin.left) - (rcCli.right - rcCli.left);
	ncH = (rcWin.bottom - rcWin.top) - (rcCli.bottom - rcCli.top);
	MoveWindow(MainWnd, 0, 0,
		ncW + bi->biWidth  * SCALE,
		ncH - bi->biHeight * SCALE, 0);
	//
	ShowWindow(MainWnd, SW_SHOW);
	UpdateWindow(MainWnd);
}
/////////////////////////////////////////////////////////////////////////////
void
InitROM()
{
	int retval;
	FILE* fp;
	int size;
	unsigned char* buff;
	ZIP zip;
	ZIPDIR dir;

	memset(mem, 0, 0x10000);

	fp = fopen(DIR FNAME, "rb");
	ASSERT(fp);
	fseek(fp, 0, SEEK_END);
	size = ftell(fp);
	rewind(fp);
	buff = malloc(size);
	ASSERT(buff);
	fread(buff, 1, size, fp);
	fclose(fp);
	//
	retval = zip_init(&zip, buff, size);
	ASSERT(retval == 0);
	retval = zip_dir(&zip, &dir);
	ASSERT(retval == 0);
	rom_size = dir.uncompressed_size;
	rom = malloc(rom_size);
	ASSERT(rom);
	retval = zip_uncompress(&zip, dir.filename, rom, rom_size);
	ASSERT(retval == rom_size);
	//
	free(buff);

	/*  */
	ASSERT(rom_size == 0x8000);
	memcpy(mem, rom, 0x8000);
}
/////////////////////////////////////////////////////////////////////////////

unsigned char
gb_read(DMG* cpu, unsigned short addr)
{
	if(addr >= 0xff00) {
		switch(addr) {
		/*----- Joypad -----*/
		//case 0xff00: /* $FF00 (P1) */
		/*----- Serial -----*/
		//case 0xff01: /* $FF01 (SB) */
		//case 0xff02: /* $FF02 (SC) */
		/*----- Timer -----*/
		case 0xff04: /* $FF04 (DIV) */
			{
				DIV_T += DIV_T0 - cpu->cycle;
				DIV_T0 = cpu->cycle;
				mem[addr] = DIV_T >> 8; /* 256Cycle+1 */
				break;
			}
		//case 0xff05: /* $FF05 (TIMA) */
		//case 0xff06: /* $FF06 (TMA) */
		//case 0xff07: /* $FF07 (TAC) */
		/*----- Interrupt -----*/
		//case 0xff0f: /* $FF0F (IF) */
		//case 0xffff: /* $FFFF (IE) */
		/*----- Sound -----*/
		//case 0xff10: /* $FF10 (NR10) */
		//case 0xff11: /* $FF11 (NR11) */
		//case 0xff12: /* $FF12 (NR12) */
		//case 0xff13: /* $FF13 (NR13) */
		//case 0xff14: /* $FF14 (NR14) */
		//case 0xff16: /* $FF16 (NR21) */
		//case 0xff17: /* $FF17 (NR22) */
		//case 0xff18: /* $FF18 (NR23) */
		//case 0xff19: /* $FF19 (NR24) */
		//case 0xff1a: /* $FF1A (NR30) */
		//case 0xff1b: /* $FF1B (NR31) */
		//case 0xff1c: /* $FF1C (NR32) */
		//case 0xff1d: /* $FF1D (NR33) */
		//case 0xff1e: /* $FF1E (NR34) */
		//case 0xff20: /* $FF20 (NR41) */
		//case 0xff21: /* $FF21 (NR42) */
		//case 0xff22: /* $FF22 (NR43) */
		//case 0xff23: /* $FF23 (NR44) */
		//case 0xff24: /* $FF24 (NR50) */
		//case 0xff25: /* $FF25 (NR51) */
		//case 0xff26: /* $FF26 (NR52) */
		/*----- LCDC -----*/
		case 0xff40: /* $FF40 (LCDC) */
		case 0xff41: /* $FF41 (STAT) */
		case 0xff42: /* $FF42 (SCY) */
		case 0xff43: /* $FF43 (SCX) */
		case 0xff44: /* $FF44 (LY) */
		case 0xff45: /* $FF45 (LYC) */
		case 0xff46: /* $FF46 (DMA) */
		case 0xff47: /* $FF47 (BGP) */
		case 0xff48: /* $FF48 (OBP0) */
		case 0xff49: /* $FF49 (OBP1) */
		case 0xff4a: /* $FF4A (WY) */
		case 0xff4b: /* $FF4B (WX) */
			{
				mem[addr] = dmgvideo_read(addr);
				break;
			}
		}
	}
	return mem[addr];
}

void
gb_write(DMG* cpu, unsigned short addr, unsigned char data)
{
	if(addr < 0x8000) {
		return;
	}
	if(addr >= 0xff00) {
		switch(addr) {
		/*----- Joypad -----*/
		case 0xff00: /* $FF00 (P1) */
			{
				data |= 0x0f;
				if(!(data & (1<<4))) {
					if(GetAsyncKeyState(VK_RIGHT)) data &= ~(1<<0);
					if(GetAsyncKeyState(VK_LEFT )) data &= ~(1<<1);
					if(GetAsyncKeyState(VK_UP   )) data &= ~(1<<2);
					if(GetAsyncKeyState(VK_DOWN )) data &= ~(1<<3);
				} else if(!(data & (1<<5))) {
					if(GetAsyncKeyState('X'      )) data &= ~(1<<0);
					if(GetAsyncKeyState('Z'      )) data &= ~(1<<1);
					if(GetAsyncKeyState(VK_BACK  )) data &= ~(1<<2);
					if(GetAsyncKeyState(VK_RETURN)) data &= ~(1<<3);
				} else {
					data = 0xff; /* $Fx=GameBoy, $3x=SuperGameBoy */
				}
				mem[addr] = data;
				return;
			}
		/*----- Serial -----*/
		//case 0xff01: /* $FF01 (SB) */
		//case 0xff02: /* $FF02 (SC) */
		/*----- Timer -----*/
		case 0xff04: /* $FF04 (DIV) */
			{
				DIV_T  = 0;
				DIV_T0 = cpu->cycle;
				mem[addr] = 0;
				break;
			}
		//case 0xff05: /* $FF05 (TIMA) */
		//case 0xff06: /* $FF06 (TMA) */
		//case 0xff07: /* $FF07 (TAC) */
		/*----- Interrupt -----*/
		case 0xff0f: /* $FF0F (IF) */
		case 0xffff: /* $FFFF (IE) */
			{
				mem[addr] = data;
				dmg_check_pending(cpu);
				return;
			}
		/*----- Sound -----*/
		//case 0xff10: /* $FF10 (NR10) */
		//case 0xff11: /* $FF11 (NR11) */
		//case 0xff12: /* $FF12 (NR12) */
		//case 0xff13: /* $FF13 (NR13) */
		//case 0xff14: /* $FF14 (NR14) */
		//case 0xff16: /* $FF16 (NR21) */
		//case 0xff17: /* $FF17 (NR22) */
		//case 0xff18: /* $FF18 (NR23) */
		//case 0xff19: /* $FF19 (NR24) */
		//case 0xff1a: /* $FF1A (NR30) */
		//case 0xff1b: /* $FF1B (NR31) */
		//case 0xff1c: /* $FF1C (NR32) */
		//case 0xff1d: /* $FF1D (NR33) */
		//case 0xff1e: /* $FF1E (NR34) */
		//case 0xff20: /* $FF20 (NR41) */
		//case 0xff21: /* $FF21 (NR42) */
		//case 0xff22: /* $FF22 (NR43) */
		//case 0xff23: /* $FF23 (NR44) */
		//case 0xff24: /* $FF24 (NR50) */
		//case 0xff25: /* $FF25 (NR51) */
		//case 0xff26: /* $FF26 (NR52) */
		/*----- LCDC -----*/
		case 0xff40: /* $FF40 (LCDC) */
		case 0xff41: /* $FF41 (STAT) */
		case 0xff42: /* $FF42 (SCY) */
		case 0xff43: /* $FF43 (SCX) */
		case 0xff44: /* $FF44 (LY) */
		case 0xff45: /* $FF45 (LYC) */
		case 0xff46: /* $FF46 (DMA) */
		case 0xff47: /* $FF47 (BGP) */
		case 0xff48: /* $FF48 (OBP0) */
		case 0xff49: /* $FF49 (OBP1) */
		case 0xff4a: /* $FF4A (WY) */
		case 0xff4b: /* $FF4B (WX) */
			{
				dmgvideo_write(addr, data);
				return;
			}
		}
	}
	mem[addr] = data;
}

int
main(int argc, char* argv[])
{
	RECT rc;
	HDC hDC;
	int t0;
	int t1;

	InitUI();
	InitROM();

	dmgvideo_reset(mem);
	dmg_reset(cpu, gb_read, gb_write, 1);

	t0 = GetTickCount();
	hDC = GetDC(MainWnd);
	GetClientRect(MainWnd, &rc);
	for(;;) {
		if(!DoMsg()) {
			break;
		}

		DIV_T0 = 456 * 154;
		dmg_run(cpu, DIV_T0);
		if(cpu->halt) cpu->cycle = 0;
		DIV_T += DIV_T0 - cpu->cycle;

		mem[0xff0f] |= DMG_V_BLANK;
		dmg_check_pending(cpu);
		dmgvideo_update(vbuff);
#ifdef REDUCE
		dmgvideo_reduce(vbuff, vbuff);
#endif /*REDUCE*/

		StretchDIBits(hDC,
			rc.left, rc.top, rc.right - rc.left, rc.bottom - rc.top,
			0, 0, pBMI->bmiHeader.biWidth, -pBMI->bmiHeader.biHeight,
			vbuff,
			pBMI,
			DIB_RGB_COLORS,
			SRCCOPY);

		for(;;) {
			t1 = GetTickCount();
			if(t1 - t0 >= FMSEC) break;
			Sleep(0);
		}
		t0 += FMSEC;
	}
	ReleaseDC(MainWnd, hDC);
}


