/*
 *	emu.c
 *
 *	GameBoy/EMU
 *
 *	* Sat Feb 19 21:54:00 JST 2005 Naoyuki Sawa
 *	- 쐬JnB
 */
#include "app.h"

/****************************************************************************
 *	
 ****************************************************************************/

int
gb_init(const char* fname)
{
	/* ͂NA܂B */
	//input = input_shift = 0;

	/* CNA܂B */
	memset(dmgmem, 0, 0x10000);

	/* ROMt@C̃tbVAhX擾܂B */
	stream_stop();  /* ĂȂ͂ǁAÔߊmɒ~ */
	rom = mmap(fname, &rom_size, 1/*DEFRAG*/);
	if(!rom) goto L_ERR;

	/* CNA܂B */
	memset(dmgmem, 0, 0x10000);

	/*{{*/
	if(rom_size != 0x8000) goto L_ERR;
	memcpy(dmgmem, rom, 0x8000);
	/*}}*/

	/* VideoZbg܂B
	 * - CPUZbgGameBoy[IPLAWX^̂ŁA
	 *   KCPUZbgɁAӑuZbgĂB
	 */
	dmgvideo_reset(dmgmem);

	/* CPUZbg܂B */
	dmgcpu_reset(gb_read, gb_write, 1/*GameBoy[IPL*/);

	return 0;

L_ERR:
	return -1;
}

int
gb_run(const char* fname, int sound)
{
	int cnt = 0;
	int div = 0;
	//
	int retval;
	int i;

	retval = gb_init(fname);
	if(retval != 0) {
		return -1;
	}

	cnt = 0;
	for(;;) {
		/* ͍XVB */
		input = 0xff;
		i = pcePadGetDirect();
		if(i & PAD_RI    ) input &= ~(1<<0);
		if(i & PAD_LF    ) input &= ~(1<<1);
		if(i & PAD_UP    ) input &= ~(1<<2);
		if(i & PAD_DN    ) input &= ~(1<<3);
		if(i & PAD_A     ) input &= ~(1<<4);
		if(i & PAD_B     ) input &= ~(1<<5);
		if(i & PAD_SELECT) input &= ~(1<<6);
		if(i & PAD_START ) input &= ~(1<<7);

		/* 456[Cycle/Line]~(ʓ144[Line]+ʊO10[Line]) */
		for(i = 0; i < 154; i++) {
			/*  */
			dmgmem[0xff44] = i; /* $FF44 (LY) */

			//dmgcpu_run(456);
			//ۂɂ́AӑũANZX⊄荞݃ANmbWTCN̂߂ɁA
			//CPU456TCNtɗpłȂ͂łB
			//sTCN⏭Ȃ߂ɂāAG~[Vx҂Ƃɂ܂B
			//ɖ肪oAsTCN𒲐ĂB
			dmgcpu_run(456 - 16);

			/* ^C}XVB(256[Cycle/Count]) */
			div += 456;
			dmgmem[0xff04] = div >> 8; /* $FF04 (DIV) */
		}

		dmgmem[0xff0f] |= DMG_V_BLANK;
		dmgcpu_check_pending();

		cnt += FPS;
		if(cnt >= 60) {
			cnt -= 60;
			dmgvideo_update(vbuff);
			dmgvideo_reduce(vbuff, vbuff);
			schedule();
			if((joy & PAD_START) && (joy & PAD_SELECT)) {
				break;
			}
		}
	}

	return 0;
}

/****************************************************************************
 *	
 ****************************************************************************/

int
gb_read_io(int addr)
{
	switch(addr) {
	/*----- Joypad -----*/
	//case 0xff00: /* $FF00 (P1) */
	/*----- Serial -----*/
	//case 0xff01: /* $FF01 (SB) */
	//case 0xff02: /* $FF02 (SC) */
	/*----- Timer -----*/
	//case 0xff04: /* $FF04 (DIV) */
	//case 0xff05: /* $FF05 (TIMA) */
	//case 0xff06: /* $FF06 (TMA) */
	//case 0xff07: /* $FF07 (TAC) */
	/*----- Interrupt -----*/
	//case 0xff0f: /* $FF0F (IF) */
	//case 0xffff: /* $FFFF (IE) */
	/*----- Sound -----*/
	//case 0xff10: /* $FF10 (NR10) */
	//case 0xff11: /* $FF11 (NR11) */
	//case 0xff12: /* $FF12 (NR12) */
	//case 0xff13: /* $FF13 (NR13) */
	//case 0xff14: /* $FF14 (NR14) */
	//case 0xff16: /* $FF16 (NR21) */
	//case 0xff17: /* $FF17 (NR22) */
	//case 0xff18: /* $FF18 (NR23) */
	//case 0xff19: /* $FF19 (NR24) */
	//case 0xff1a: /* $FF1A (NR30) */
	//case 0xff1b: /* $FF1B (NR31) */
	//case 0xff1c: /* $FF1C (NR32) */
	//case 0xff1d: /* $FF1D (NR33) */
	//case 0xff1e: /* $FF1E (NR34) */
	//case 0xff20: /* $FF20 (NR41) */
	//case 0xff21: /* $FF21 (NR42) */
	//case 0xff22: /* $FF22 (NR43) */
	//case 0xff23: /* $FF23 (NR44) */
	//case 0xff24: /* $FF24 (NR50) */
	//case 0xff25: /* $FF25 (NR51) */
	//case 0xff26: /* $FF26 (NR52) */
	/*----- LCDC -----*/
	case 0xff40: /* $FF40 (LCDC) */
	case 0xff41: /* $FF41 (STAT) */
	case 0xff42: /* $FF42 (SCY) */
	case 0xff43: /* $FF43 (SCX) */
	case 0xff44: /* $FF44 (LY) */
	case 0xff45: /* $FF45 (LYC) */
	case 0xff46: /* $FF46 (DMA) */
	case 0xff47: /* $FF47 (BGP) */
	case 0xff48: /* $FF48 (OBP0) */
	case 0xff49: /* $FF49 (OBP1) */
	case 0xff4a: /* $FF4A (WY) */
	case 0xff4b: /* $FF4B (WX) */
		{
			dmgmem[addr] = dmgvideo_read(addr);
			break;
		}
	}
	return dmgmem[addr];
}

void
gb_write_io(int addr, int data)
{
	switch(addr) {
	/*----- Joypad -----*/
	case 0xff00: /* $FF00 (P1) */
		{
			data &= 0xf0;
			if(!(data & (1<<4))) {
				data |= input & 15;
			} else if(!(data & (1<<5))) {
				data |= input >> 4;
			} else {
				data = 0xff; /* $Fx=GameBoy, $3x=SuperGameBoy */
			}
			dmgmem[addr] = data;
			return;
		}
	/*----- Serial -----*/
	//case 0xff01: /* $FF01 (SB) */
	//case 0xff02: /* $FF02 (SC) */
	/*----- Timer -----*/
	case 0xff04: /* $FF04 (DIV) */
		{
			dmgmem[addr] = 0; /* Reset */
			break;
		}
	//case 0xff05: /* $FF05 (TIMA) */
	//case 0xff06: /* $FF06 (TMA) */
	//case 0xff07: /* $FF07 (TAC) */
	/*----- Interrupt -----*/
	case 0xff0f: /* $FF0F (IF) */
	case 0xffff: /* $FFFF (IE) */
		{
			dmgmem[addr] = data;
			dmgcpu_check_pending();
			return;
		}
	/*----- Sound -----*/
	//case 0xff10: /* $FF10 (NR10) */
	//case 0xff11: /* $FF11 (NR11) */
	//case 0xff12: /* $FF12 (NR12) */
	//case 0xff13: /* $FF13 (NR13) */
	//case 0xff14: /* $FF14 (NR14) */
	//case 0xff16: /* $FF16 (NR21) */
	//case 0xff17: /* $FF17 (NR22) */
	//case 0xff18: /* $FF18 (NR23) */
	//case 0xff19: /* $FF19 (NR24) */
	//case 0xff1a: /* $FF1A (NR30) */
	//case 0xff1b: /* $FF1B (NR31) */
	//case 0xff1c: /* $FF1C (NR32) */
	//case 0xff1d: /* $FF1D (NR33) */
	//case 0xff1e: /* $FF1E (NR34) */
	//case 0xff20: /* $FF20 (NR41) */
	//case 0xff21: /* $FF21 (NR42) */
	//case 0xff22: /* $FF22 (NR43) */
	//case 0xff23: /* $FF23 (NR44) */
	//case 0xff24: /* $FF24 (NR50) */
	//case 0xff25: /* $FF25 (NR51) */
	//case 0xff26: /* $FF26 (NR52) */
	/*----- LCDC -----*/
	case 0xff40: /* $FF40 (LCDC) */
	case 0xff41: /* $FF41 (STAT) */
	case 0xff42: /* $FF42 (SCY) */
	case 0xff43: /* $FF43 (SCX) */
	case 0xff44: /* $FF44 (LY) */
	case 0xff45: /* $FF45 (LYC) */
	case 0xff46: /* $FF46 (DMA) */
	case 0xff47: /* $FF47 (BGP) */
	case 0xff48: /* $FF48 (OBP0) */
	case 0xff49: /* $FF49 (OBP1) */
	case 0xff4a: /* $FF4A (WY) */
	case 0xff4b: /* $FF4B (WX) */
		{
			dmgvideo_write(addr, data);
			return;
		}
	}
	dmgmem[addr] = data;
}

void
gb_write_rom(int addr, int data)
{
	/* TODO: oNؑ */
}

